/* 
 * Sixby
 * CSE142, Spring 1999
 * Homework 4
 * Traffic animation

  SPACE INVADERS!!!

 * Section BA
 *
 */


#include "gp142.h"
#include <stdio.h>
#include <math.h>

#include <time.h>
	/* 
	* <time.h> is included so the current time can be accessed
	* to initialize the random number generator.  If you don't
	* use random numbers (and you don't have to) you can either
	* ignore this #include or delete it.
	*/

/* Logical constants */
#define TRUE    		1
#define FALSE   		0

#define FILL 0

/* Menu buttons: */

/* Top-left coordinates of button palette */
#define MENU_TOP		(GP142_YMAX - 5)
#define MENU_LEFT		(-GP142_XMAX + 5)

/* Height and width of buttons in pixels */
#define BUTTON_HEIGHT  	25
#define BUTTON_WIDTH 	75

/* Number of buttons */
#define NUM_BUTTONS 	7


/* Possible locations of mouse clicks: */
#define BUTTON_CLICK 1
#define OTHER_CLICK 0

/* y-coordinate of the top of the ground in the landscape */
#define HORIZON -1 *(GP142_YMAX / 2)

/* Vertical center and width of highway */
#define HIGHWAY_CENTER ((-GP142_YMAX + HORIZON) / 3)
#define HIGHWAY_WIDTH  10

#define MAX_VADERS 10	//# of vaders on the screen at reset


/* Height and width of a single ship */
#define SHIP_HEIGHT 24
#define SHIP_WIDTH  40

// Laser stuff
#define LASER_SPEED 35
#define LASER_HEIGHT 25

#define STAR_SPEED 6

#define SHOT_SPEED 10		//shots fired by vaders
#define SHOT_RADIUS 4
#define SHOT_COLOR YELLOW


//STRUCT
//used for the vaders, laser, ect
typedef struct{
	int x, y, exist, color, dir;	//xy coords, exist(t/f) and color
	}	where;

//for the shots fired by the vaders

typedef struct{
	int x, y, radius;	
	}	shot;



/*****************************************************************************
     FUNCTION PROTOTYPES
*****************************************************************************/

/* Draw the background, including the star at coordinates star_x and star_y */
void draw_landscape(int	star_x,int star_y,int star2_y);

/* Draw the buttons */
void draw_buttons();

/* Return kind of mouse click (in a button, etc.) */
int  classify_mouse_click(int mouse_x, int mouse_y);

/* Process button click at location x, y.  Update ship speed,  */
/* direction, color, and whether traffic is moving as needed. */
void handle_button(int x, int y, int *ship_speed,
				   int *ship_direction, int *shoot, where *laser,
				   int *ship_x, where vader[], int *ship_exist);

/* Update star coordinates star_x, star_y for one tick */
void move_star(int *star_x, int *star_y, int *star2_y);

//shots fired by the vaders
void move_shots(shot lemon[], where vader[], int *ship_exist, int ship_x, int ship_y);
void draw_shots(shot lemon[]);

/* Update all vehicle x, y coordinates, given current x, y */
/* location, direction (+1 or -1), and speed in pixels per tick. */
void move_ship(int *x, int *y, int *direction, int speed);
void draw_ship(int x, int y, int color);		//it would look easier if the ship was a struct
												//this won't happen due to time limitations.
void golaser(where *laser, where vader[], int *shoot);
void reset_laser(where *laser);

void draw_vader(where vader);
void move_vaders(where vader[], int *vader_ydir);	//vaders
void show_vaders(where vader[]);
void reset_vaders(where vader[]);

void explosion(where something);
void ship_explode(int x, int y);


/*****************************************************************************

     MAIN

*****************************************************************************/

/*
 * Main program contents:
 *   - Major program variables that persist throughout execution
 *   - Event loop that processes GP142 events until the user quits,
 *     and updates variables and redraws the window as needed.
 */
int main(void)
{


	/* Event handling and buttons: */
	int  quit;				/* = "user has selected quit"				*/
	int  event;				/* the most recent GP142 event				*/
	char key_pressed;		/* last keyboard character from key event	*/
	int  mouse_x, mouse_y;	/* x and y coordinates of latest mouse event*/
	int  click_kind;		/* kind of mouse click (button, etc.)		*/

	/* Information about the star: */
	int star_x, star_y, star2_y;	//offsets 2 sets of stars			
	
	/* Information about vehicles in the animation:							*/
	/* [Only one ship now - will need to be changed to add more]				*/
	int ship_x, ship_y;		/* current position of the ship					*/
	int ship_exist;

	int ship_direction;		/* current direction: +1=right, -1=left			*/
	int ship_color;			/* color of the ship								*/
	int ship_speed;			/* speed in pixels per tick when traffic moving	*/	
	int traffic_moving;		/* = "traffic is currently moving"				*/
	int vader_ydir;
	int shoot, x = 0;
	int i;


	where vader[MAX_VADERS];	//there will be 10 vaders.
	where laser;


	shot lemon[MAX_VADERS];	//I needed a name.  'Lemon' only sounds appropriate.

	/* Initialize graphics package, clear the window,	*/
	/* turn logging off, and start animation.			*/
	GP142_open();
	GP142_logging(LOG_OFF);
	GP142_clear();
	GP142_animate(ANI_RUN);
//----------------------------------------------------------------
	for (i = 0; i < MAX_VADERS; i ++)
	{
		if(i%2 == 0)					//resets all vader properties
			vader[i].color = ORANGE;	//depending on even or odd tag
		else
			vader[i].color = NAVY_BLUE;	
	}
//-------------------------------------------------------------

	reset_vaders(vader);	//puts all vaders into original formation
	reset_laser(&laser);

	for(i = 0; i < MAX_VADERS; i++)	//we assume one shot per vader
	{
		lemon[i].x = vader[i].x;
		lemon[i].y = vader[i].y - 700;
	}

	vader_ydir = -3;
	shoot = FALSE;

	/* set initial location of the star */
	star_x = GP142_XMAX - 50;
	star_y = -GP142_YMAX/2;
	star2_y = star_y + 700;

	/* set initial conditions for the ship */
	ship_x = 0;
	ship_y = HIGHWAY_CENTER;
	ship_direction = +1;			//now a struct.  The original code was very sloppy
	ship_speed = 3;					
	ship_color = RED;				
	ship_exist = TRUE;

	traffic_moving = TRUE;
	
	/* Draw initial landscape, buttons, and traffic */
	draw_landscape(star_x,star_y, star2_y);
	draw_buttons( );



	/*
	 * Main event loop:
	 * ---- ----- -----
	 * Wait for the next user action, decode it, and call an
	 * appropriate function to handle it.  Repeat until the
	 * user selects quit.
	 */
	quit = FALSE;
	while (!quit) {
		
		/* get next event */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_pressed);
		
		/* perform appropriate action depending on kind of event */
		switch (event) {
		case GP142_QUIT:
			/* Quit selected */
			quit = TRUE;
			break;
			
		case GP142_KBD:
			/* Key pressed.  Not used now.  If the program should		*/
			/* react to keyboard events, insert something appropriate	*/
			/* here.  Note that scanf CANNOT be used with GP142.		*/
			break;
			
		case GP142_MOUSE:
			/* Mouse click.  Determine if in a menu button	*/
			/* or elsewhere and process accordingly.		*/
			click_kind = classify_mouse_click(mouse_x, mouse_y);
			if (click_kind == BUTTON_CLICK) {
				handle_button(mouse_x, mouse_y, &ship_speed,
								&ship_direction, &shoot, &laser, &ship_x, vader,
								&ship_exist);
			} else {
				/* insert code here (and additional else-if statements) */
				/* to react to mouse clicks elsewhere on the screen */
			}
			break;
			
		case GP142_PERIODIC:
			/* Timer interval event.  Update everything	*/
			/* that needs to change as time advances.	*/

			move_star(&star_x, &star_y, &star2_y);

			move_ship(&ship_x, &ship_y, &ship_direction, ship_speed);
			
			break;
			
		default:
			/* unknown event */
			break;
			
		}  /*end switch */
		
		/* Redraw everything */
		draw_landscape(star_x, star_y, star2_y);
		draw_buttons();

		if(ship_exist == TRUE)
			draw_ship(ship_x, ship_y, ship_color);

	
		if(shoot == TRUE)	//see if a shot has been fired.
		{
			if(laser.y > GP142_YMAX)
			{
			
				shoot = FALSE;		//turns off laser
				reset_laser(&laser);
			}
			else
			{
				laser.y = laser.y + LASER_SPEED;	//move the laser up 
				golaser(&laser, vader, &shoot);
			}
		}

		for(i = 0; i < MAX_VADERS; i ++)
		{
			if(vader[i].exist == TRUE)		//see if we've destroyed them all
				x = x + 1;
		}

		if(x == 0) 
		{
			reset_vaders(vader);	
			for(i = 0; i <  MAX_VADERS; i ++)
			{
					/* change vader color */
				vader[i].color = (vader[i].color+1) % MAX_COLORS;
				if(vader[i].color == BLACK)
					vader[i].color = (vader[i].color+1) % MAX_COLORS;
			}
		}
		x = 0;		//reset counter

		move_shots(lemon, vader, &ship_exist, ship_x, ship_y);

		draw_shots(lemon);
		move_vaders(vader, &vader_ydir);
		show_vaders(vader);
	}  /* end event loop */
	
	
	/* Termination: shut down graphics window and exit */
	GP142_close();
	return 0;
}  /*end main */


/*****************************************************************************

     BACKGROUND LANDSCAPE

*****************************************************************************/


/* Draw the background, including the star at coordinates star_x and star_y */
void draw_landscape(int star_x, int star_y, int star2_y)
{
	int text_offset = -GP142_XMAX + 15;	/* horizontal offset of text */
	int text_size   = 12;				/* size of text font */

											
	/* Draw the sky */										//Someday I'll figure it out.
	GP142_rectangleXY(BLACK, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, GP142_YMAX, FILL);


	
	/* Draw the stars */
	GP142_circleXY(WHITE, star_x+ 15, star_y+ 110, 1);
	GP142_circleXY(WHITE, star_x+ 9, star_y - 25, 1);
	GP142_circleXY(WHITE, star_x- 423, star_y - 400, 1);
	GP142_circleXY(WHITE, star_x- 510, star_y - 300, 1);
	GP142_circleXY(WHITE, star_x- 189, star_y - 400, 1);
	GP142_circleXY(WHITE, star_x- 140, star_y - 240, 1);
	GP142_circleXY(WHITE, star_x- 240, star_y - 89, 1);
	GP142_circleXY(WHITE, star_x- 350, star_y + 100, 1);
	GP142_circleXY(WHITE, star_x- 59, star_y + 142, 1);
	GP142_circleXY(WHITE, star_x- 300, star_y + 123, 1);

//2nd cycle of stars offset down...doesn't work right.
	GP142_circleXY(WHITE, star_x+ 15, star2_y+ 110, 1);
	GP142_circleXY(WHITE, star_x+ 9, star2_y - 25, 1);
	GP142_circleXY(WHITE, star_x- 423, star2_y - 400, 1);
	GP142_circleXY(WHITE, star_x- 510, star2_y - 300, 1);
	GP142_circleXY(WHITE, star_x- 189, star2_y - 400, 1);
	GP142_circleXY(WHITE, star_x- 140, star2_y - 240, 1);
	GP142_circleXY(WHITE, star_x- 240, star2_y - 89, 1);
	GP142_circleXY(WHITE, star_x- 350, star2_y + 100, 1);
	GP142_circleXY(WHITE, star_x- 59, star2_y + 142, 1);
	GP142_circleXY(WHITE, star_x- 300, star2_y + 123, 1);


//TITLE
	
	GP142_printfXY (YELLOW, -GP142_XMAX/2 + 50, -GP142_YMAX+30, text_size + 4,
		"STAR WARS %c EPISODE 2", 174);
	GP142_printfXY (WHITE, -GP142_XMAX/2 + 50, -GP142_YMAX+10, text_size,
		"Programmed by Mark Sixbey 1999");

	
} 

/*****************************************************************************

     BUTTONS AND MOUSE CLICKS

*****************************************************************************/


/* Draws the buttons */
void draw_buttons( )
{
	int i;
	int text_offset = MENU_LEFT+10;	/* offset of button text in button */
	int font_size = 12;				/* size of button text */
	
	/* draw rectangles for each button */
	for(i = 0; i < NUM_BUTTONS; i++) {
		GP142_rectangleXY(WHITE,
			MENU_LEFT,
			MENU_TOP - i * BUTTON_HEIGHT,
			MENU_LEFT + BUTTON_WIDTH,
			MENU_TOP - (i + 1)*BUTTON_HEIGHT, 1);
	}
	
	/* display button text */
	i = MENU_TOP - (BUTTON_HEIGHT/2) - (font_size/2);
	GP142_printfXY(ICE_BLUE, text_offset, i, font_size, "NEW GAME");	
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(WHITE, text_offset, i, font_size, "STOP");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(WHITE, text_offset, i, font_size, "GO");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(WHITE, text_offset, i, font_size, "SLOWER");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(WHITE, text_offset, i, font_size, "SPEEDUP");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(WHITE, text_offset, i, font_size, "REVERSE");
		
	i -= BUTTON_HEIGHT;
	GP142_printfXY(RED, text_offset, i, font_size, "SHOOT!");
}

/* Classify mouse click at (mouse_x,mouse_y) and return kind */
int  classify_mouse_click(int mouse_x, int mouse_y)
{
	if ((mouse_x > MENU_LEFT) &&
		(mouse_x < MENU_LEFT + BUTTON_WIDTH) &&
		(mouse_y < MENU_TOP) &&
		(mouse_y > (MENU_TOP - NUM_BUTTONS*BUTTON_HEIGHT)))
		return BUTTON_CLICK;
	else
		return OTHER_CLICK;
}


//PROCESS BUTTON CLICKS

void handle_button(int x, int y, int *ship_speed,
				   int *ship_direction, int *shoot, where *laser,
				   int *ship_x, where vader[],
				  int *ship_exist)
{
	int buttonNum;		/* number of selected button */

	/* Convert y coordinate to button number from top. */
	buttonNum = (MENU_TOP - y)/BUTTON_HEIGHT;	 
	
	switch(buttonNum) {
	case 0:
	
	reset_vaders(vader);
		*ship_speed = 0;
		*ship_x = 0;
		*ship_exist = TRUE;
		break;
	case 1:
		/* stop */
		*ship_speed = 0;
		break;
		
	case 2:
	/* go */			//notice this code looks a lot like the ship program?
		*ship_speed = 8;
		break;
	case 3:
		/* slow down */
		*ship_speed = *ship_speed - 1;
		if (*ship_speed < 0)
			*ship_speed = 0;
		break;
		
	case 4:
	
				/* speed up */
		*ship_speed = *ship_speed + 1;
		break;
	case 5:
		
			/* reverse */
		*ship_direction = - *ship_direction;
		break;
	case 6:
	
			//shoot
		if(*shoot == FALSE)
		{
			*shoot = TRUE;
			laser->x = *ship_x;
			laser->exist = TRUE;
			laser->y = HORIZON + SHIP_HEIGHT - 10;
		}
		break;
	}
}



/*****************************************************************************

     TRAFFIC AND OTHER ANIMATED OBJECTS

*****************************************************************************/


/* Update star coordinates star_x, star_y by one tick */
void move_star(int *star_x, int *star_y, int *star2_y) {

	*star_y = *star_y - STAR_SPEED;
	*star2_y = *star2_y - STAR_SPEED;

	if (*star_y < -GP142_YMAX - 300) {
		*star_y = -*star_y + 100;
	}

}

void move_ship(int *x, int *y, int *direction, int speed)
{

	int trial_x;		/* new value for x coordinate */

	/* move vehicle.  If it moves off the edge, reverse direction */
	trial_x = *x + (*direction * speed);
	if (abs(trial_x) > GP142_XMAX - SHIP_WIDTH/2)
		*direction = - (*direction);
	else
		*x = trial_x;
}



/* Draw a single ship of the given color with horizontal */
/* center x and bottom y*/
void draw_ship(int x, int y, int color) {


	GP142_triangleXY(WHITE,
		x - SHIP_WIDTH,		//cool shit for the ship
		y - 25,
		x,
		y,
		x + SHIP_WIDTH,
		y + SHIP_HEIGHT + 7,
		FILL);	

	GP142_triangleXY(WHITE,
		x + SHIP_WIDTH,
		y - 25,
		x,
		y,
		x - SHIP_WIDTH,
		y + SHIP_HEIGHT + 7,
		FILL);	



//MAIN
	GP142_circleXY(WHITE, x, y, 22);	

//BODY	
	GP142_rectangleXY(MED_GRAY, x - SHIP_WIDTH/2, y + SHIP_HEIGHT/4,
						x + SHIP_WIDTH/2, y, FILL);
//CAB
	GP142_rectangleXY(LT_GRAY, x - SHIP_WIDTH/3, y + SHIP_HEIGHT*3/4,
						x + SHIP_WIDTH/3, y + SHIP_HEIGHT/2, FILL);
//GUN
	GP142_rectangleXY(MED_GRAY, x + 2, y + SHIP_HEIGHT,
						x - 2, y + SHIP_HEIGHT + 8, FILL);
//circle?

	GP142_circleXY(MED_GRAY, x, y, 10);		

}

//*************************************************



void draw_vader(where vader)
{
	//vader goes here

	GP142_triangleXY(RED,
		vader.x - SHIP_WIDTH,		//cool shit for the vaders
		vader.y,
		vader.x,
		vader.y,
		vader.x + SHIP_WIDTH,
		vader.y + SHIP_HEIGHT + 7,
		FILL);	
	GP142_triangleXY(RED,
		vader.x + SHIP_WIDTH,
		vader.y,
		vader.x,
		vader.y,
		vader.x - SHIP_WIDTH,
		vader.y + SHIP_HEIGHT + 7,
		FILL);	

	//BODY	
	GP142_rectangleXY(vader.color,
		vader.x - SHIP_WIDTH/2,
		vader.y,
		vader.x + SHIP_WIDTH/2,
		vader.y + SHIP_HEIGHT*3/4, FILL);

	GP142_circleXY(BLACK, vader.x + SHIP_WIDTH/3, vader.y + 10, 2);		//eyes or something
	GP142_circleXY(BLACK, vader.x - SHIP_WIDTH/3, vader.y + 10, 2);

//CAB
	GP142_rectangleXY(MED_GRAY, 
		vader.x - SHIP_WIDTH/3, 
		vader.y - 5,
		vader.x + SHIP_WIDTH/3, 
		vader.y, FILL);

}

void reset_vaders(where vader[])
{
	int i;
	for (i = 0; i <  MAX_VADERS; i ++)
	{
		vader[i].x = -GP142_XMAX + (SHIP_WIDTH + 30) + (i * 50);
	
		vader[i].exist = TRUE;

	
		if(i%2 == 0){					//resets all vader properties
			//depending on even or odd tags
			vader[i].y = GP142_YMAX + 45;
			vader[i].dir = -3;
		}
		else
		{
		
			vader[i].y = GP142_YMAX + (50 + SHIP_HEIGHT);
			vader[i].dir = 3;
		}
	}
}

void move_vaders(where vader[], int *vader_ydir)
{
	int i;
	for (i = 0; i < MAX_VADERS; i ++)
	{

		vader[i].x = vader[i].x +  vader[i].dir;

//see if we've gone outside the boundaries
		if((vader[i].x > GP142_XMAX - SHIP_WIDTH) || (vader[i].x < -GP142_XMAX + SHIP_WIDTH))
		{
			vader[i].dir = -vader[i].dir;
		}

	if(vader[i].y < GP142_YMAX/2 - 100)
		*vader_ydir = 3;
	else
		if(vader[2].y > GP142_YMAX- SHIP_HEIGHT)
			*vader_ydir = -3;

	vader[i].y = vader[i].y + *vader_ydir;
	
	}

}

void show_vaders(where vader[])
{
	int i;
	for(i = 0; i < MAX_VADERS; i ++)
	{
		if(vader[i].exist == TRUE)
			draw_vader(vader[i]);
	}
	//display vaders
}

//**************************************************************************

void golaser(where *laser, where vader[], int *shoot)
{
	int i;


	GP142_rectangleXY(RED,laser->x - 1,laser->y,		//draws laser
		laser->x + 1,laser->y + LASER_HEIGHT, FILL);

	//we'll see if the laser has gone out of the screen
		if((laser->y > GP142_YMAX))
		{
			*shoot = FALSE;
			reset_laser(laser);
		}

		for(i=0;i < MAX_VADERS;i=i+1)
		{
			if((laser->x < vader[i].x + SHIP_WIDTH/2) && (laser->x > vader[i].x - SHIP_WIDTH/2) 
				&& (laser->y - SHIP_HEIGHT/2 > vader[i].y - LASER_HEIGHT) 
				&& (laser->y < vader[i].y + LASER_HEIGHT + SHIP_HEIGHT/2))
			{
				vader[i].exist = FALSE;		//adjust settings accordingly
			
				*shoot = FALSE;
				reset_laser(laser);
				explosion(vader[i]);
			}
		}


	
}
//   _________________________________________________________________________

void reset_laser(where *laser)
{

	laser->y = HORIZON;
	laser->color = RED;

}
//---------------------------------------------------------------------------


//shots fired by the vaders
void move_shots(shot lemon[], where vader[], int *ship_exist, int ship_x, int ship_y)
{
	int i;

	for(i = 0; i < MAX_VADERS; i++)
	{
		lemon[i].y = lemon[i].y - SHOT_SPEED;
		if(lemon[i].y < -GP142_YMAX - 400)		//move, check if it's off the screen
		{										//if so, set it to it's corresponding
			if(vader[i].exist == TRUE)			//vader's coordinates
			{
				lemon[i].y = vader[i].y;
				lemon[i].x = vader[i].x;
			}
		}
	}
	
	for(i = 0; i < MAX_VADERS; i++)		//see if I got hit
	{
		if(lemon[i].x > ship_x - SHIP_WIDTH/3 && lemon[i].x < ship_x + SHIP_WIDTH/3
			&& lemon[i].y < ship_y && lemon[i].y > ship_y - SHIP_HEIGHT)
		{
			if(*ship_exist == TRUE)
				ship_explode(ship_x, ship_y);	//only performs one operation

			*ship_exist = FALSE;

		}
	}

}


void draw_shots(shot lemon[])		//draws the shots fired by the vaders
{

	int i;

	for(i = 0; i < MAX_VADERS; i ++)
	{
		GP142_circleXY(SHOT_COLOR, lemon[i].x, lemon[i].y, SHOT_RADIUS);	
	}

}
//*****************************************************

//EXPLOSION...making stuff go boom.
void explosion(where something)
{

	GP142_circleXY(ORANGE, something.x, something.y, 35);	

}

void ship_explode(int x, int y)
{
	GP142_circleXY(YELLOW, x, y, 40);	

}
